/* -*- mode: c++ -*- */
// rdiagonal.h
// Mquina para diagonalizar matrices reales y simtricas

#ifndef _RDIAGONAL_
#define _RDIAGONAL_

#include <smatriz.h>
#include <ccontrol.h>

using namespace std;

// Class RDiagonal
/// Mquina para diagonalizar matrices reales y simtricas
/**
 *\ingroup P5
 */

class RDiagonal {
 private:
///  matriz simtrica
    SMatriz* pM; 
///   matriz diagonalizada 
    RMatriz* pD; 
///   matriz de autovectores
    RMatriz* pV; 
///  precisin en diagonalizacin
    double pEps;  
/// nmero mximo de iteraciones
    int pMaxiter;  
/// Cuadro de Control
    CControl pCC;       

  /// Constructor de copia privado
  /** Las clases tipo "mquina" no pueden copiarse
   */
    RDiagonal(const RDiagonal& rd) {}
  /// operador = privado
    RDiagonal& operator = (const RDiagonal& rd){}

    // Las funciones de diagonalizacin son privadas
    // a la clase.
  /// diagonaliza por jacobi
    void jacobi(RMatriz& a, RMatriz& r, double eps, double maxiter);
  /// efecta una rotacin jacobi
    void rotJacobi(RMatriz& a, RMatriz& r, int p, int q);	

 public:
  /// constructor
    RDiagonal();
    /// Destructor
    ~RDiagonal();

  /// Establece una matriz para diagonalizar
    void eMatriz(const SMatriz& m,
		 double precision=1e-5, int maxiter = 100);

    // Acciones
/// devuelve la matriz simtrica original
    SMatriz& matriz() ;  
/// devuelve matriz diagonalizada
    RMatriz& diagonal();  
/// devuelve matriz autovectores
    RMatriz& autovectores() ;  
};

#endif   /* _RDIAGONAL_ */
