/* -*- mode: c++ -*- */
// vector.h
// Clases de vectores

#ifndef _VECTOR___
#define _VECTOR___

#include <iostream>
#include <string>

using namespace std;

// Clase RVector
/// Define un vector de nmeros reales (ampliado con respecto a P4)
/**
 *\ingroup P5
 */
class RVector {
 private:
/// arreglo dinmico de elementos
    double* pElem;   
/// dimensin del vector 
    int pDim;        

 public:
    /// Constructor por defecto (vector de dimensin 1)
    RVector();
  /// Constructor estndar 
    RVector(int dimension);
    /// Constructor de copia
    RVector(const RVector& m);
  /// Destructor
    ~RVector();

    // Funciones de acceso
/// devuelve la dimensin del vector
    int dimension() const;  
    // no permite asignar la dimensin del vector excepto en constructor

    // Operadores
  /// v(i) lectura i=1,2,...n
    const double& operator () (int indice) const;
  /// v(i) escritura i=1,2,...n
    double& operator () (int indice);
    /// v1=v2
    RVector& operator = (const RVector& v);
    /// v1+=v2
    RVector& operator += (const RVector& v);
    /// v1-=v2
    RVector& operator -= (const RVector& v);
    /// v1*=d
    RVector& operator *= (double a);
    /// anula todos los elementos del vector
    RVector& anulaElementos();
    /// lee elementos de un fichero
    int lee(string fichero);
    /// escribe elementos en un fichero
    int escribe(string fichero);
};

// Operaciones con vectores
/// -v
RVector operator - (const RVector& v);
/// v1+v2
RVector operator + (const RVector& v1, const RVector& v2);
/// v1-v2
RVector operator - (const RVector& v1, const RVector& v2);
/// producto escalar
double  operator * (const RVector& v1, const RVector& v2);
/// v*d
RVector operator * (const RVector& v1, double d);
/// d*v
RVector operator * (double d, const RVector& v1);
/// producto escalar
double productoEscalar(const RVector& v1, const RVector& v2);
/// mximo a partir del ndice j
int  maximo(const RVector& v1, int j=1);
/// mnimo a partir del ndice j
int  minimo(const RVector& v1, int j=1);
/// escribe un vector por pantalla
ostream& operator << (ostream& s, const RVector& v);

#endif   /* _VECTOR___ */
