// xalin
// Ejemplo de resolucin de problemas
// de lgebra lineal

#include <iostream>
#include <linalg.h>
#include <alineal.h>
#include <error.h>
#include <matutil.h>

int main ()
{
    string fmatriz="m1e1.dat";
    string fvector="v1e1.dat";

    //Crea un algoritmo de lgebra lineal
    ALineal xal;
    int n = 3;
    RMatriz m(n,n);
    // Y leela del disco
    m.lee(fmatriz);
    cout << " matriz m = " << m << endl;
    
    // Establece la matriz en el algoritmo
    xal.eMatriz(m);
    // Calcula la inversa y el determinante
    RMatriz minv = xal.inversa();
    cout << " minv = " << minv << endl;
    cout << " m*minv = " << m*minv << endl;
    cout << " minv*m = " << minv*m << endl;
    cout << "determinante = "<<xal.det()<<endl;

    // Crea un nuevo vector 
    RVector w(n);
    // Y leelo 
    w.lee(fvector);
    cout << " vector = " << w << endl;
    // Establece el vector en el algoritmo
    xal.eVector(w);
    // Resolvemos el sistema
    RVector x = xal.x();
    cout << " Vector de soluciones" 
	 << x << endl;
    // Y Comprobamos:
    cout << " m * x - w=" << m*x -w << endl;
    cout <<"Comprobamos que podemos calcular el vector incognitas"<<endl;
    cout <<"r(x,y,z) a partir de la inversa de la matriz de"<<endl;
    cout <<"coeficientes mediante la relacion;"<<endl;
    cout << "x=A**(-1)*w, donde w(x,y,z) es el vector de terminos independientes."<<endl;
    cout << "x= "<< minv*w <<endl;
    return 0;
}
