// xpermutacion.cpp

#include <iostream>
#include <permutacion.h>
#include <vector.h>
#include <linalg.h>
#include <error.h>
#include <matutil.h>

// Ejemplo de uso de permutaciones.
// Calcula todas las permutaciones del grupo de orden 3
// Permuta un vector de acuerdo a stas.
// Comprueba la composicin de permutaciones y la
// permutacin inversa

int main()
{
    RVector v(3);  // declara un vector de 3 dimensiones
    v(1) = 10; v(2) = 20; v(3) = 30; // y lo inicializa

    cout << "vector ejemplo v" << v << endl << endl;
    
    cout << " Calcula p*v y p^{-1}*(p*v) para todas "
	 << " las permutaciones del grupo" << endl << endl;
    
    // p e incializan a la permutacin unidad
    Permutacion p(3);
    int i = 0;
    
    // Avanza p a la siguiente permutacin en orden lexicogrfico
    // Por convencin, la funcin p.siguiente() devuelve la permutacin
    // nula (igual que la funcin pnula(int n)) 
    // al final de la cadena lexicogrfica. (La permutacin nula 
    // de dimensin n es por convencin (0,0,....0))
    
    // itera sobre todas las permutaciones del grupo
    while (p !=  pnula(3)){
	cout << endl << " permutacin p"<<++i
	     << " = " << p << endl;
	cout << " p*v = " << p*v << endl;
	cout << " p^{-1}*(p*v) = " << pinv(p)*p*v << endl;
	p.siguiente();
    }

    cout << endl<<endl<<"Composicin de permutaciones" <<endl;
    Permutacion p1(3); // p1 se inicializa a (1,2,3)
    p1.intercambia(1,2); // p1 = (2,1,3)
    cout << " v = " <<v<<endl
	 << " p1 = " <<p1<<endl
	 << "p1*v="
	 << p1*v << endl;

    cout << "Permutacin simple, p2 = 1<-->3" <<endl;
    Permutacion p2(3);       // p2 = (1,2,3)
    p2.intercambia(1,3);     // p2 = (3,2,1)
    cout << " v = " <<v<< endl
	 <<" p2 = " <<p2<< endl
	 << "p2*v="
	 << p2*v << endl;
    
    cout << " p = p2*p1" <<p2*p1 << endl;  // (3,1,2)
    cout << " v = " <<v<<endl 
	 << " p2*p1*v = " <<p2*p1*v << endl;
    RVector v1 = p1*v;
    cout << " p1*v = " <<v1<< endl
	 <<" p2*(p1*v) = " <<p2*v1 << endl;

    return EXITO;
}
